import { csv, select,legendColor } from 'd3';
import { scatterPlot } from './scatterPlot';


const csvUrl = [
  'https://raw.githubusercontent.com/NHRK555/Student_marks/main/Courses112.csv', 
].join('');

// Data gets splits, using parsing
const parseRow = (d) => {
  d.A = +d.A;
  d.B = +d.B;
  d.C = +d.C;
  d.D = +d.D;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

// values to be viewed on X-labels
const xValue = (d) => d.C;
const yValue = (d) => d.D;
const rxValue = (d) => d.A;
const ryValue = (d) => d.B;
const Personvalue = (d) => d.Country;
const colorValue = d => d.Country;
const colorLabel = 'Country';

//Adding the legends
const main = async () => {
  const data = await csv(csvUrl, parseRow);
  const x = xValue((d) => d.D);
  const y = yValue((d) => d.A);
  const marker = (d) => {
        	switch(d){
            case 'US':
              return 'yellow';
            default:
              return 'red';
          }
        }
  
  const marks = data.map((d) => ({
          x: xValue((d) => d.D),
          y: yValue((d) => d.A),
          Person: Personvalue(d),
          color: marker(Personvalue(d)),
        	rx: rxValue(d),
          ry: ryValue(d),
                      
        }));
  
  
//Defining scatterplot structure
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.D)
    .yValue((d) => d.A)
    .margin({
      top: 35,
      right: 50,
      bottom: 80,
      left: 95,

    })
    .radius(5);
  
  
 const g = svg.append('g')
          .attr('transform', `translate(${100},${100})`);

      const colorLegendG = g.append('g')
          .attr('transform', `translate(${100}, 150)`);


//Declaring the shape and structure of data points  
svg
          .selectAll('circle')
          .data(marks)
          .join('circle')
          .attr('cx', (d) => d.x)
          .attr('cy', (d) => d.y)
        	.attr('fill', (d) => d.color)
        	.attr('rx', (d) => (d.rx))
        	.attr('ry', (d) => (d.ry));
  
  const columns = [
    'D',
    'B',
    'C',
    'A',
  ];
  
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);  /* Generates  'petal_width',
    'B',
    'petal_length',
    'A'*/
		svg.selectAll('text').remove();
    svg.call(plot);
    
      colorLegendG.append('text')
          .attr('class', 'legend-label')
          .attr('x', -70)
          .attr('y', -210)
          .style("font-style","italic")
          .style("stroke","black")
          .text(colorLabel);
// Title
svg.append("text").attr("x", 450).attr("y", 20).text("Percentages of four different Products imported in each country").style("font-size", "20px").attr("alignment-baseline","left")

// Add labels in the legend

svg.append("text").attr("x", 150).attr("y", 75).text("US").style("font-size", "20px").attr("alignment-baseline","middle")
svg.append("text").attr("x", 150).attr("y", 100).text("Canada").style("font-size", "20px").attr("alignment-baseline","middle")
    svg
        	.append("text")
        	.attr('transform', 'rotate(-90)')
        	.attr('x',0 - (height /2))
        	.attr("y",  height/12)
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
        	.text("Percentages of products imported"); 
    // Add points for legend
   
		svg.append("circle").attr("cx",130).attr("cy",75).attr("r", 6).style("fill", "yellow")
		svg.append("circle").attr("cx",130).attr("cy",100).attr("r", 6).style("fill", "red")
   // plot D on x-axis
    if(i % columns.length==0) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","Ariel")
        	.style("font-weight","bold")
      		.text("A");
     // plot B on x-axis
    else if(i % columns.length==1) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","Ariel")
        	.style("font-weight","bold")
      		.text("B");
     // plot C on x-axis
    else if(i % columns.length==2) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","Ariel")
        	.style("font-weight","bold")
      		.text("C");
     // plot A on x-axis
       else 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  480 )
        	.style("text-anchor", "middle")
        	.style("font-style","Ariel")
        	.style("font-weight","bold")
      		.text("D");
    i++;
  }, 1700);// every 1.7 seconds change the visualization
};
main();



